<?php
/*
Plugin Name: WP Sort Posts
Plugin URI: http://sitehint.ru/?p=757
Description: 
Version: 1.0
Author: TrueFalse
Author URI: http://red-book-cms.ru
License: GPLv2 or later
Text Domain: wpsp
Domain Path: /languages
*/

# Загрузка строк локализации:
load_plugin_textdomain('wpsp', false, dirname( plugin_basename( __FILE__ ) ). '/languages/');

# Сортировка записей:
function wpsp_orderby_posts($vars) {  
  $params = wpsp_get_orderby_select();
  $vars->set('orderby', $params['orderby']);
  $vars->set('order', $params['order']);  
  $vars->set('ignore_sticky_posts', 1);  
  return $vars;
}
add_filter('pre_get_posts', 'wpsp_orderby_posts');

# Обрабатываем POST с выпадающего списка:
function wpsp_get_orderby_select() {
  $result = array(
    '1' => ' selected="selected"',
    '2' => '',
    '3' => '',
    '4' => '',
    'orderby' => 'date',
    'order' => 'DESC'
  );  
  if (intval($_GET['wpsp_orderby_posts']))
    switch ($_GET['wpsp_orderby_posts']) {
      case '1': // Сортировать по заголовку:
        $result['orderby'] = "title";
        $result['order'] = "ASC";
        break;
      case '2': // Сортировать по дате: сначала новые:
        $result['orderby'] = "date";
        $result['order'] = "DESC";
        $result['2'] = ' selected="selected"';
        $result['1'] = '';
        break;
      case '3': // Сортировать по дате: сначала старые:
        $result['orderby'] = "date";
        $result['order'] = "ASC";
        $result['3'] = ' selected="selected"';
        $result['1'] = '';
        break;
      case '4': // Сортировать по дате последней правки:               
        $result['order'] = "modified";
        $result['4'] = ' selected="selected"';
        $result['1'] = '';
        break;
    }  
  return $result;
}
add_filter('wp_head', 'wpsp_get_orderby_select');

# Вывод формы на экран:
function wpsp_orderby_posts_form() {
  $params = wpsp_get_orderby_select();
  echo "
  <form method=\"get\" id=\"order\">". __('Sort posts', 'wpsp'). "
    <select name=\"wpsp_orderby_posts\" onchange=\"this.form.submit()\">
      <option value=\"1\"{$params['1']}>". __('by title', 'wpsp'). "</option>
      <option value=\"2\"{$params['2']}>". __('by date (new forward)', 'wpsp'). "</option>
      <option value=\"3\"{$params['3']}>". __('by date (old onwards)', 'wpsp'). "</option>
      <option value=\"4\"{$params['4']}>". __('by date modified', 'wpsp'). "</option>
    </select>
  </form>";
}

?>